<%- include('../partials/header') %>
<%- include('../partials/scripts') %>
<%- include('../partials/select2') %>
</head>

<body class="min-vh-100 d-flex flex-column">
	<%- include('../partials/navbar') %>
	<div class="main-content d-flex flex-column flex-grow-1">
		<%- include('../partials/topbar') %>
		<%- include('./header', { active: 'new' }) %>
		<!-- Page content -->
		<div class="container-fluid mt--7 flex-grow-1">
			<div class="row">
				<div class="col-xl-12">
					<div class="card">
						<div class="card-header">
							<div class="row align-items-center">
								<div class="col-12">
									<h3 class="mb-0">Nový výsledek</h3>
								</div>
							</div>
						</div>
						<div class="card-body bg-secondary">
							<form action="./" method="POST" id="new-result">
								<div class="pl-lg-4">
									<div class="row">
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-type'>Typ</label>
												<select class='form-control' id='select-type'>
													<option value="qualification">Kvalifikace</option>
													<option value="spider">Pavouk</option>
												</select>
											</div>
										</div>
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-team'>Tým</label>
												<select class='form-control' id='select-team'></select>
											</div>
										</div>
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-category'>Kategorie</label>
												<select class='form-control' id='select-category'></select>
											</div>
										</div>
										<div class='col-3'>
											<div class='form-group'>
												<label for='select-style'>Styl</label>
												<select class='form-control' id='select-style'>
													<option value="top">Vrchem</option>
													<option value="bottom">Spodem</option>
												</select>
											</div>
										</div>
									</div>
								</div>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col" id="new-result-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary"
												id="new-result-button">Vytvořit</button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<%- include('../partials/footer') %>
		</div>
	</div>
	<%- include('../partials/scripts-file-end') %>
	<script>
		$(document).ready(() => {
			let $selectType = $('select#select-type').select2({
				minimumResultsForSearch: -1
			})

			let $selectTeam = $('select#select-team').select2()
			$selectTeam.html(`<option selected="selected" value>Načítání...</option>`)
			$selectTeam.prop("disabled", true);
			API.team.list().done((listOfTeams) => {
				$selectTeam.html(`<option selected="selected" value disabled="disabled">Vyber tým</option>`)
				listOfTeams.forEach((team) => {
					$selectTeam.append(`<option value="${team._id}">${team.name}</option>`)
				})
				$selectTeam.prop("disabled", false);
				$selectTeam.on('select2:select', function (e) {
					$selectCategory
						.val(listOfTeams.filter(team => {
							return team._id === $selectTeam.val()
						})[0].category._id)
						.prop('disabled', true)
						.trigger('change')
				})
			})

			let $selectCategory = $('select#select-category').select2({
				minimumResultsForSearch: -1
			})
			$selectCategory.html(`<option selected="selected" value>Načítání...</option>`)
			$selectCategory.prop("disabled", true);
			API.category.list().done((listOfCategories) => {
				// $selectCategory.html(`<option selected="selected" value disabled="disabled">Vyber kategorii</option>`)
				$selectCategory.html(`<option selected="selected" value disabled="disabled">Po vybrání týmu se vybere kategorie</option>`)
				listOfCategories.forEach((category) => {
					$selectCategory.append(`<option value="${category._id}">${category.name}</option>`)
				})
				// $selectCategory.prop("disabled", false);
			})

			let $selectStyle = $('select#select-style').select2({
				minimumResultsForSearch: -1
			})

			$('form#new-result').submit(function (event) {
				event.preventDefault()
				let $status = $('div#new-result-status')
				$status
					.empty()
					.append(
						$('<div>', { class: 'alert alert-default alert-dismissible fade show', role: 'alert' }).append(
							$('<span>', { class: 'alert-icon' }).append(
								$('<i>', { class: 'fas fa-circle-notch fa-spin' })
							),
							$('<span>', { class: 'alert-text' }).append(
								'Zpracovávám'
							),
							$('<button>', { type: 'button', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'Close' }).append(
								$('<span>', { 'aria-hidden': 'true' }).html('&times;')
							)
						)
					)
					.show()

				API.result
					.new(
						$selectType.val(),
						$selectTeam.val(),
						$selectCategory.val(),
						$selectStyle.val()
					).done(function (responseFromServer) {
						if (responseFromServer === 'ok') {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Gratuluji!'),
										' Úspěšně jste vytvořil(a) nový výsledek'
									)
								)
								.show()

							// Redirect to list page
							setTimeout(function () {
								window.location.href = './list';
							}, 3500)
						} else {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Ach ne! '),
										responseFromServer
									)
								)
								.show()
						}
					})
			})
		})
	</script>
	<%- include('../partials/file-end') %>
